/*============================================================*

 *============================================================*/

#include "p4.h"
#include <stdio.h>

#define ZERO 0
#define HIGH 1
#define LOW  2

main(argc, argv)
     int    argc;
     char   **argv;
{

  int    i, nproc, status, size, type, from;
  int    *incoming;
  long   total_elapsed;

  timer_reset();

  p4_initenv(&argc, argv);
  p4_create_procgroup();

  if(p4_get_my_id() != 0){
    slave(); 
    p4_wait_for_end();
    exit(0);
  }

  nproc = p4_num_total_ids();

  if (argc < 2) {
    printf("Usage: (1) status of communication and computation (high, low)\n");
    exit(0);
  }

  /* input the data from the file - allocate memory as required */
  printf("The number of processors : %d\n", nproc - 1);
  printf("The status : %s \n",argv[1]);
fflush(stdout);

  if ( strcmp(argv[1], "high") == ZERO ) {
    status = HIGH;
  }
  else if ( strcmp(argv[1], "low") == ZERO ) {
    status = LOW;
  }

  size = sizeof(int);
  type = 100;
  for ( i = 1 ; i < nproc ; i++ ) {
    p4_send(type, i, &status, size);
  }

  type = 200;
  from = -1;
  incoming = NULL;
  
  p4_recv(&type, &from, &incoming, &size);

  total_elapsed = timer_elapsed();

  p4_dprintf("Total Elapsed Time : %d (milliseconds)\n", total_elapsed);

  p4_wait_for_end();
}













